package com.example.android_sdk_tutorial;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.Set;

import android.app.Activity;
import android.app.Dialog;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

import com.idtechproducts.device.*;
//import com.idtechproducts.device.sdkdemo.R;
import com.idtechproducts.device.ReaderInfo.DEVICE_TYPE;

public class MainActivity extends Activity implements  OnReceiverListener{

	// declaring the instance of the UniPayReader;
	private IDT_PipReader myPipReader = null;
	private TextView connectStatusTextView;  
	private TextView textLog;
	private TextView lcdLog;
	private Button btnGetFirmware;
	private Button btnStartCTLS;
	private Button btnCancelCTLS;
	private Handler handler = new Handler();
    private boolean isReaderConnected = false;
    private String info = "";
	private String detail = "";
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		handler = new Handler();		
		btnStartCTLS = (Button)findViewById(R.id.btn_StartCTLS);
		btnCancelCTLS = (Button)findViewById(R.id.btn_CancelCTLS);
		btnGetFirmware = (Button)findViewById(R.id.btn_getFirmware);
	    textLog = (TextView)findViewById(R.id.textLog);
	    lcdLog = (TextView)findViewById(R.id.lcdLog);
	    connectStatusTextView = (TextView)findViewById(R.id.status_text);
		if(myPipReader!=null){
			myPipReader.unregisterListen();
			myPipReader.release();
			myPipReader = null;
		}
		myPipReader = new IDT_PipReader(this,this);
		myPipReader.registerListen();
		loadXMLfile();
		

		btnGetFirmware.setOnClickListener(new Button.OnClickListener(){  
	        public void onClick(View v) {
	        	info = "Getting Firmware\n";
	        	detail = "";
	        	handler.post(doUpdateStatus);
	        	StringBuilder sb = new StringBuilder();
	            int ret = myPipReader.device_getFirmwareVersion(sb);
	            if (ret == ErrorCode.SUCCESS) {
					info += "Firmware Version: " + sb.toString();
					detail = "";
					handler.post(doUpdateStatus);
				}
				else {
					info += "GetFirmwareVersion: Failed\n";
					info += "Status: "+ myPipReader.device_getResponseCodeString(ret)+"";
					detail = "";
					handler.post(doUpdateStatus);							
					}
	        }  
	    });
		
		btnStartCTLS.setOnClickListener(new Button.OnClickListener(){  
	        public void onClick(View v) {;
	        detail = "";
	        info = "Starting CTLS Transaction\n";
        	handler.post(doUpdateStatus);
				myPipReader.ctls_startTransaction(1.00, 0.00, 0, 30, null);
	        }  
	    });
		
		btnCancelCTLS.setOnClickListener(new Button.OnClickListener(){  
	        public void onClick(View v) {
	        	detail = "";
		        info = "Canceling CTLS Transaction\n";
	        	handler.post(doUpdateStatus);
				myPipReader.ctls_cancelTransaction();
	        }  
	    });
		
		
	}
	
	

	@Override
	public void ICCNotifyInfo(byte[] arg0, String arg1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void LoadXMLConfigFailureInfo(int arg0, String arg1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void autoConfigCompleted(StructConfigParameters arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void autoConfigProgress(int arg0) {
		// TODO Auto-generated method stub
		
	}
	
	private Runnable doUpdateLabel = new Runnable()
	{
	    public void run()
	    {
	        if(!isReaderConnected){
	            connectStatusTextView.setText("PipReader DISCONNECTED");
	        }
	        else{
	            connectStatusTextView.setText("PipReader CONNECTED");
	        }
	    }
	};
	@Override
	public void deviceConnected() {
		isReaderConnected = true;
		handler.post(doUpdateLabel);	
		
		ResDataStruct respData = new ResDataStruct();
		byte[] TLV = Common.getByteArray("DFEE2D01029F0607A000000476D0009F160400BC614E9F55009F1C009F4E009F15009F560500000000019F5701009F5801019F5901019F5A01009F5B0100");
		myPipReader.ctls_setConfigurationGroup(TLV, respData);
	}

	@Override
	public void deviceDisconnected() {
		isReaderConnected = false;
	    handler.post(doUpdateLabel);		
	}
	
	
	@Override
	public void emvTransactionData(IDTEMVData emvData) {

	}




	@Override
	public void msgAudioVolumeAjustFailed() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void msgRKICompleted(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void msgToConnectDevice() {
		// TODO Auto-generated method stub
		
	}

	private Runnable doUpdateStatus = new Runnable()
	{
		public void run()
		{		
			lcdLog.setText(info);
			textLog.setText(detail);
		}
	};
	
	
	@Override
	//Callback function for MSR swipe
	public void swipeMSRData(IDTMSRData card) {
		if (card.result != ErrorCode.SUCCESS)
		{
			info = "MSR card data didn't read correctly\n";
			info += ErrorCodeInfo.getErrorCodeDescription(card.result);
			if (card.result != ErrorCode.FAILED_NACK)
			{
				detail = "";
				handler.post(doUpdateStatus);
				return;
			}
		}
		else
		{
			info = "MSR Card tapped Successfully";
		}
		detail = Common.parse_MSRData(myPipReader.device_getDeviceType(), card);
		handler.post(doUpdateStatus);
	}
	

	@Override
	public void timeout(int arg0) {
		// TODO Auto-generated method stub
		
	}
	
	private String getXMLFileFromRaw(String fileName ,int res){
		//the target filename in the application path
		String fileNameWithPath = null;
		fileNameWithPath = fileName;
		String newFilename = fileName;
	
		try {
			InputStream in = getResources().openRawResource(res);
			int length = in.available();
			byte [] buffer = new byte[length];
			in.read(buffer);    	   
			in.close();
			deleteFile(fileNameWithPath);
			FileOutputStream fout = openFileOutput(fileNameWithPath, MODE_PRIVATE);
			fout.write(buffer);
			fout.close();
    	   
			// to refer to the application path
			File fileDir = this.getFilesDir();
			fileNameWithPath = fileDir.getParent() + java.io.File.separator + fileDir.getName();
			fileNameWithPath += java.io.File.separator+newFilename;
	   	   
		} catch(Exception e){
			e.printStackTrace();
			fileNameWithPath = null;
		}
		return fileNameWithPath;
	}
	
	private String getConfigurationFileFromRaw( ){
		return getXMLFileFromRaw("idt_unimagcfg_default.xml",R.raw.idt_unimagcfg_default);
		}
	private boolean isFileExist(String path) {
    	if(path==null)
    		return false;
	    File file = new File(path);
	    if (!file.exists()) {
	      return false ;
	    }
	    return true;
    }
	private void loadXMLfile(){
		
	    //load the XML configuratin file
	    String fileNameWithPath = getConfigurationFileFromRaw();
	    if(!isFileExist(fileNameWithPath)) { 
	    	fileNameWithPath = null; 
	    }        	
	    /////////////////////////////////////////////////////////////////////////////////
		// Network operation is prohibited in the UI Thread if target API is 11 or above.
		// If target API is 11 or above, please use AsyncTask to avoid errors.
	    myPipReader.config_setXMLFileNameWithPath(fileNameWithPath);
	    Log.d("Demo Info >>>>>","loadingConfigurationXMLFile begin.");
	    myPipReader.config_loadingConfigurationXMLFile(true);
	    /////////////////////////////////////////////////////////////////////////////////
	}

	@Override
	public void dataInOutMonitor(byte[] arg0, boolean arg1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void msgBatteryLow() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void lcdDisplay(int mode, String[] lines, int timeout) {
		// TODO Auto-generated method stub
		
	}
	
	public void lcdDisplay(int mode, String[] lines, int timeout, byte[] languageCode, byte messageId) {

	}
	
	
}
